#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""
#define prev predidushiy

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXN = 1e5 + 5;
pii scanline[MAXN * 2];
pii part1[MAXN];
pii part2[MAXN];
int sorted_arry[MAXN];
int part1_arry[MAXN];
int part2_arry[MAXN];
int arry[MAXN * 2];
int cnty;
int used[MAXN];
int rmq[MAXN * 6];
int there[MAXN * 6];
int bpv;

void s_segplus(int v, int vl, int vr, int l, int r, int val) {
	if (vr <= l || r <= vl) {
		return;
	}
	if (l <= vl && vr <= r) {
		//cerr << "add " << v << " " << val << endl;
		there[v] += val;
		rmq[v] += val;
		return;
	}
	int vm = (vl + vr) / 2;
	s_segplus(v * 2, vl, vm, l, r, val);
	s_segplus(v * 2 + 1, vm, vr, l, r, val);
	rmq[v] = min(rmq[v * 2], rmq[v * 2 + 1]) + there[v];
}

int s_getmin(int v, int vl, int vr, int l, int r) {
	//cerr << v << " " << vl << " " << vr << " " << l << " " << r << endl;
	if (vr <= l || r <= vl) {
		return INF;
	}
	if (l <= vl && vr <= r) {
		//cerr << "here " << rmq[v] << endl;
		return rmq[v];
	}
	int vm = (vl + vr) / 2;
	return min(s_getmin(v * 2, vl, vm, l, r), s_getmin(v * 2 + 1, vm, vr, l, r)) + there[v];
}

int r, c;

int get_down(int x) {
	if (x < 0) {
		return -x;
	}
	return x;
}

int get_up(int x) {
	if (x < r - c) {
		return c + (x - (1 - c));
	}
	return r + c - 1 - (x - (r - c));
}

bool check(int lx, int rx) {
	//cerr << "check " << lx << " " << rx << endl;
	int from = min(get_down(lx), get_down(rx - 1));
	if (lx <= 0 && 0 < rx) {
		from = 0;
	}
	int to = max(get_up(lx), get_up(rx - 1));
	if (lx <= r - c && r - c < rx) {
		to = r + c - 1;
	}
	int ly = lower_bound(arry, arry + cnty, from) - arry;
	int ry = lower_bound(arry, arry + cnty, to) - arry;
	if (ly < 0 || ry == cnty) {
		return false;
	}
	if (s_getmin(1, 0, bpv, ly, ry) == 0) {
		return false;
	}
	return true;
}

void solve() {
	int n;
	cin >> r >> c >> n;
	vector<pii> inp;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		--x; --y;
		inp.push_back({x - y, x + y});
		//cerr << x - y << " " << x + y << endl;
		part1[i] = {x - y, i};
		part2[i] = {x - y, i};
		sorted_arry[i] = x + y;
	}
	sort(sorted_arry, sorted_arry + n);
	int cnt_sortedy = unique(sorted_arry, sorted_arry + n) - sorted_arry;
	sort(part1, part1 + n);
	sort(part2, part2 + n);
	int lg = -1, rg = r + c + 1;
	int tcounter = 0;
	while (rg - lg > 1) {
		int mid = (lg + rg) / 2;

		for (int i = 0; i < n; ++i) {
			int ind = part1[i].ss;
			part1[i].ff = inp[ind].ff - mid;
			part2[i].ff = inp[ind].ff + mid + 1;
			//cerr << inp[ind].ff - mid << " " << inp[ind].ss - mid << " " << inp[ind].ff + mid + 1 << " " << inp[ind].ss + mid + 1 << endl;
		}
		merge(part1, part1 + n, part2, part2 + n, scanline);

		for (int i = 0; i < cnt_sortedy; ++i) {
			part1_arry[i] = sorted_arry[i] - mid;
			part2_arry[i] = sorted_arry[i] + mid + 1;
		}
		merge(part1_arry, part1_arry + cnt_sortedy, part2_arry, part2_arry + cnt_sortedy, arry);
		cnty = unique(arry, arry + cnt_sortedy * 2) - arry;
		/*
		for (int i = 0; i < cnty; ++i) {
			cerr << arry[i] << " ";
		}
		cerr << endl;
		*/
		bpv = 1;
		while (bpv < cnty) {
			bpv *= 2;
		}

		fill(rmq, rmq + bpv * 2, 0);
		fill(there, there + bpv * 2, 0);
		tcounter++;

		bool flag = true;
		int prev = 1 - c;
		for (pii p : scanline) {
			if (p.ff >= r) {
				break;
			}
			if (prev != p.ff && p.ff > 1 - c) {
				if (!check(prev, p.ff)) {
					flag = false;
					break;
				}
			}
			int ind = p.ss;
			int from = lower_bound(arry, arry + cnty, inp[ind].ss - mid) - arry;
			int to = lower_bound(arry, arry + cnty, inp[ind].ss + mid + 1) - arry;
			if (used[ind] != tcounter) {
				used[ind] = tcounter;
				s_segplus(1, 0, bpv, from, to, 1);
			} else {
				s_segplus(1, 0, bpv, from, to, -1);
			}
			prev = p.ff;
		}

		if (!check(prev, r)) {
			flag = false;
		}

		if (!flag) {
			lg = mid;
		} else {
			rg = mid;
		}
	}

	cout << rg << "\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}