#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""
#define prev predidushiy

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXN = 1e5 + 5;
pii scanline[MAXN * 2];
pii part1[MAXN];
pii part2[MAXN];
int sorted_arry[MAXN];
int part1_arry[MAXN];
int part2_arry[MAXN];
int arry[MAXN * 2];
int cnty;
int used[MAXN];
int rmq[MAXN * 6];
int there[MAXN * 6];
int bpv;
int tcounter = 0;

void s_segplus(int v, int vl, int vr, int l, int r, int val) {
	if (vr <= l || r <= vl) {
		return;
	}
	if (l <= vl && vr <= r) {
		//cerr << "add " << v << " " << val << endl;
		there[v] += val;
		rmq[v] += val;
		return;
	}
	int vm = (vl + vr) / 2;
	s_segplus(v * 2, vl, vm, l, r, val);
	s_segplus(v * 2 + 1, vm, vr, l, r, val);
	rmq[v] = min(rmq[v * 2], rmq[v * 2 + 1]) + there[v];
}

int s_getmin(int v, int vl, int vr, int l, int r) {
	//cerr << v << " " << vl << " " << vr << " " << l << " " << r << endl;
	if (vr <= l || r <= vl) {
		return INF;
	}
	if (l <= vl && vr <= r) {
		//cerr << "here " << rmq[v] << endl;
		return rmq[v];
	}
	int vm = (vl + vr) / 2;
	return min(s_getmin(v * 2, vl, vm, l, r), s_getmin(v * 2 + 1, vm, vr, l, r)) + there[v];
}

vector<pii> rmq2;
vector<int> there2;

void s_segplus2(int v, int vl, int vr, int l, int r, int val) {
	if (vr <= l || r <= vl) {
		return;
	}
	if (l <= vl && vr <= r) {
		//cerr << "add " << v << " " << val << endl;
		there2[v] += val;
		rmq2[v].ff += val;
		rmq2[v].ss += val;
		return;
	}
	int vm = (vl + vr) / 2;
	s_segplus2(v * 2, vl, vm, l, r, val);
	s_segplus2(v * 2 + 1, vm, vr, l, r, val);
	rmq2[v].ff = min(rmq2[v * 2].ff, rmq2[v * 2 + 1].ff) + there2[v];
	rmq2[v].ss = min(rmq2[v * 2].ss, rmq2[v * 2 + 1].ss) + there2[v];
}

int s_getmin2_0(int v, int vl, int vr, int l, int r) {
	//cerr << v << " " << vl << " " << vr << " " << l << " " << r << endl;
	if (vr <= l || r <= vl) {
		return INF;
	}
	if (l <= vl && vr <= r) {
		//cerr << "here " << rmq[v] << endl;
		return rmq2[v].ff;
	}
	int vm = (vl + vr) / 2;
	return min(s_getmin2_0(v * 2, vl, vm, l, r), s_getmin2_0(v * 2 + 1, vm, vr, l, r)) + there2[v];
}

int s_getmin2_1(int v, int vl, int vr, int l, int r) {
	//cerr << v << " " << vl << " " << vr << " " << l << " " << r << endl;
	if (vr <= l || r <= vl) {
		return INF;
	}
	if (l <= vl && vr <= r) {
		//cerr << "here " << rmq[v] << endl;
		return rmq2[v].ss;
	}
	int vm = (vl + vr) / 2;
	return min(s_getmin2_1(v * 2, vl, vm, l, r), s_getmin2_1(v * 2 + 1, vm, vr, l, r)) + there2[v];
}

int r, c;

int get_down(int x) {
	if (x < 0) {
		return -x;
	}
	return x;
}

int get_up(int x) {
	if (x < r - c) {
		return c + (x - (1 - c));
	}
	return r + c - 1 - (x - (r - c));
}

bool check(int lx, int rx) {
	//cerr << "check " << lx << " " << rx << endl;
	int from = min(get_down(lx), get_down(rx - 1));
	if (lx <= 0 && 0 < rx) {
		from = 0;
	}
	int to = max(get_up(lx), get_up(rx - 1));
	if (lx <= r - c && r - c < rx) {
		to = r + c - 1;
	}
	int ly = lower_bound(arry, arry + cnty, from) - arry;
	if (arry[ly] != from) {
		--ly;
	}
	int ry = lower_bound(arry, arry + cnty, to) - arry;
	if (ly < 0 || ry == cnty) {
		return false;
	}
	if (s_getmin(1, 0, bpv, ly, ry) == 0) {
		return false;
	}
	return true;
}



bool check2(int lx, int rx, vector<int> const& arry) {
	//cerr << "check2 " << lx << " " << rx << endl;
	int from = min(get_down(lx), get_down(rx - 1));
	if (lx <= 0 && 0 < rx) {
		from = 0;
	}
	int to = max(get_up(lx), get_up(rx - 1));
	if (lx <= r - c && r - c < rx) {
		to = r + c - 1;
	}
	int ly = lower_bound(arry.begin(), arry.end(), from) - arry.begin();
	if (arry[ly] != from) {
		--ly;
	}
	int ry = lower_bound(arry.begin(), arry.end(), to) - arry.begin();
	if (ly < 0 || ry == szof(arry)) {
		return false;
	}
	if (lx + 1 != rx) {
		return s_getmin2_0(1, 0, bpv, ly, ry) != 0 && s_getmin2_1(1, 0, bpv, ly, ry) != 0;
	}
	if (!(lx & 1)) {
		return s_getmin2_0(1, 0, bpv, ly, ry) != 0;
	}
	//cerr << "here" << endl;
	return s_getmin2_1(1, 0, bpv, ly, ry) != 0;
}

vector<pii> inp;
int n;

bool check(int sr) {
	vector<pii> scanline;
	vector<int> arry;
	for (int i = 0; i < n; ++i) {
		scanline.push_back({inp[i].ff - sr, i});
		scanline.push_back({inp[i].ff + sr + 1, i});
		arry.push_back(inp[i].ss - sr);
		arry.push_back(inp[i].ss + sr + 1);
	}
	sort(arry.begin(), arry.end());
	arry.erase(unique(arry.begin(), arry.end()), arry.end());
	int tmp = szof(arry);
	for (int i = 0; i < tmp; ++i) {
		if (i == tmp - 1 || arry[i] + 1 != arry[i + 1]) {
			arry.push_back(arry[i] + 1);
		}
	}
	sort(arry.begin(), arry.end());
	arry.erase(unique(arry.begin(), arry.end()), arry.end());
	/*
	for (int num : arry) {
		cerr << num << " ";
	}
	cerr << endl;
	*/
	bpv = 1;
	while (bpv < szof(arry)) {
		bpv *= 2;
	}
	rmq2 = vector<pii>(bpv * 2);
	there2 = vector<int>(bpv * 2);
	for (int i = 0; i < szof(arry); ++i) {
		if (arry[i] & 1) {
			rmq2[bpv + i] = {1, 0};
		} else {
			rmq2[bpv + i] = {0, 1};
		}
	}

	for (int i = bpv - 1; i > 0; --i) {
		rmq2[i].ff = min(rmq2[i * 2].ff, rmq2[i * 2 + 1].ff);
		rmq2[i].ss = min(rmq2[i * 2].ss, rmq2[i * 2 + 1].ss);
	}

	++tcounter;

	sort(scanline.begin(), scanline.end());
	int prev = 1 - c;
	for (pii p : scanline) {
		if (p.ff >= r) {
			break;
		}
		if (prev != p.ff && p.ff > 1 - c) {
			if (!check2(prev, p.ff, arry)) {
				return false;
			}
		}
		int ind = p.ss;
		int from = lower_bound(arry.begin(), arry.end(), inp[ind].ss - sr) - arry.begin();
		int to = lower_bound(arry.begin(), arry.end(), inp[ind].ss + sr + 1) - arry.begin();
		if (used[ind] != tcounter) {
			used[ind] = tcounter;
			s_segplus2(1, 0, bpv, from, to, 1);
		} else {
			s_segplus2(1, 0, bpv, from, to, -1);
		}
		prev = p.ff;
	}
	if (!check2(prev, r, arry)) {
		return false;
	}
	return true;
}

void solve() {
	cin >> r >> c >> n;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		--x; --y;
		inp.push_back({x - y, x + y});
		//cerr << x - y << " " << x + y << endl;
		part1[i] = {x - y, i};
		part2[i] = {x - y, i};
		sorted_arry[i] = x + y;
	}
	sort(sorted_arry, sorted_arry + n);
	int cnt_sortedy = unique(sorted_arry, sorted_arry + n) - sorted_arry;
	sort(part1, part1 + n);
	sort(part2, part2 + n);
	int lg = -1, rg = r + c + 1;
	
	while (rg - lg > 1) {
		int mid = (lg + rg) / 2;

		for (int i = 0; i < n; ++i) {
			int ind = part1[i].ss;
			part1[i].ff = inp[ind].ff - mid;
			part2[i].ff = inp[ind].ff + mid + 1;
			//cerr << inp[ind].ff - mid << " " << inp[ind].ss - mid << " " << inp[ind].ff + mid + 1 << " " << inp[ind].ss + mid + 1 << endl;
		}
		merge(part1, part1 + n, part2, part2 + n, scanline);

		for (int i = 0; i < cnt_sortedy; ++i) {
			part1_arry[i] = sorted_arry[i] - mid;
			part2_arry[i] = sorted_arry[i] + mid + 1;
		}
		merge(part1_arry, part1_arry + cnt_sortedy, part2_arry, part2_arry + cnt_sortedy, arry);
		cnty = unique(arry, arry + cnt_sortedy * 2) - arry;
		/*
		for (int i = 0; i < cnty; ++i) {
			cerr << arry[i] << " ";
		}
		cerr << endl;
		*/
		bpv = 1;
		while (bpv < cnty) {
			bpv *= 2;
		}

		fill(rmq, rmq + bpv * 2, 0);
		fill(there, there + bpv * 2, 0);
		tcounter++;

		bool flag = true;
		int prev = 1 - c;
		for (pii p : scanline) {
			if (p.ff >= r) {
				break;
			}
			if (prev != p.ff && p.ff > 1 - c) {
				if (!check(prev, p.ff)) {
					flag = false;
					break;
				}
			}
			int ind = p.ss;
			int from = lower_bound(arry, arry + cnty, inp[ind].ss - mid) - arry;
			int to = lower_bound(arry, arry + cnty, inp[ind].ss + mid + 1) - arry;
			if (used[ind] != tcounter) {
				used[ind] = tcounter;
				s_segplus(1, 0, bpv, from, to, 1);
			} else {
				s_segplus(1, 0, bpv, from, to, -1);
			}
			prev = p.ff;
		}

		if (!check(prev, r)) {
			flag = false;
		}

		if (!flag) {
			lg = mid;
		} else {
			rg = mid;
		}
	}
	//cerr << rg << endl;

	if (check(lg)) {
		cout << lg << "\n";
	} else {
		cout << rg << "\n";
	}
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}