#!/usr/bin/env bash
#   *** validation ***
scripts/run-validator-tests.sh
scripts/run-checker-tests.sh

#    *** tests ***
mkdir -p tests
echo "Generating test #2"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 12 14 50 0 10 0 567232672" "tests/02" 2
echo "Generating test #3"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 43 30 50 0 100 0 297526274" "tests/03" 3
echo "Generating test #4"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 9 48 50 0 100000 0 176437274" "tests/04" 4
echo "Generating test #5"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 50 50 50 0 100 0 108306844" "tests/05" 5
echo "Generating test #6"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 50 50 50 0 100000 0 525470706" "tests/06" 6
echo "Generating test #7"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 38 17 50 0 10 0 907921968" "tests/07" 7
echo "Generating test #8"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 9 46 50 0 100 0 926935616" "tests/08" 8
echo "Generating test #9"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 21 39 50 0 100000 0 663950686" "tests/09" 9
echo "Generating test #10"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 50 50 50 0 100 0 102805835" "tests/10" 10
echo "Generating test #11"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 50 50 50 0 100000 0 271565455" "tests/11" 11
echo "Generating test #12"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 17 29 50 6 10 0 506936104" "tests/12" 12
echo "Generating test #13"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 43 28 50 2 100 0 127210785" "tests/13" 13
echo "Generating test #14"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 16 22 50 6 100000 0 726963940" "tests/14" 14
echo "Generating test #15"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 50 50 50 10 100 0 569635980" "tests/15" 15
echo "Generating test #16"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 50 50 50 10 100000 0 801226402" "tests/16" 16
echo "Generating test #17"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 35 33 50 5 10 0 78886024" "tests/17" 17
echo "Generating test #18"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 39 40 50 4 100 0 235448560" "tests/18" 18
echo "Generating test #19"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 23 31 50 3 100000 0 265777290" "tests/19" 19
echo "Generating test #20"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 50 50 50 10 100 0 609969880" "tests/20" 20
echo "Generating test #21"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 50 50 50 10 100000 0 885808061" "tests/21" 21
echo "Generating test #22"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 980 203 1000 0 10 0 579778419" "tests/22" 22
echo "Generating test #23"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 243 741 1000 0 100 0 328168384" "tests/23" 23
echo "Generating test #24"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 8 778 1000 0 1000000000 0 36438052" "tests/24" 24
echo "Generating test #25"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 1000 0 100 0 178111059" "tests/25" 25
echo "Generating test #26"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 1000 0 1000000000 0 435908091" "tests/26" 26
echo "Generating test #27"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 106 271 1000 0 10 0 459510149" "tests/27" 27
echo "Generating test #28"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 703 23 1000 0 100 0 657157675" "tests/28" 28
echo "Generating test #29"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 87 46 1000 0 1000000000 0 420518797" "tests/29" 29
echo "Generating test #30"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 1000 0 100 0 173539316" "tests/30" 30
echo "Generating test #31"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 1000 0 1000000000 0 453299939" "tests/31" 31
echo "Generating test #32"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 278 11 1000 2 10 0 582811088" "tests/32" 32
echo "Generating test #33"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 41 497 1000 9 100 0 633214110" "tests/33" 33
echo "Generating test #34"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 306 263 1000 7 1000000000 0 987448311" "tests/34" 34
echo "Generating test #35"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 1000 10 100 0 147950302" "tests/35" 35
echo "Generating test #36"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 1000 10 1000000000 0 194047863" "tests/36" 36
echo "Generating test #37"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 918 723 1000 3 10 0 217948387" "tests/37" 37
echo "Generating test #38"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 677 63 1000 1 100 0 314249789" "tests/38" 38
echo "Generating test #39"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 109 73 1000 8 1000000000 0 537270530" "tests/39" 39
echo "Generating test #40"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 1000 10 100 0 37121827" "tests/40" 40
echo "Generating test #41"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 1000 10 1000000000 0 42781244" "tests/41" 41
echo "Generating test #42"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 324 776 100000 0 10 1000000000 142620365" "tests/42" 42
echo "Generating test #43"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 572 424 100000 0 100 1000000000 746773248" "tests/43" 43
echo "Generating test #44"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 304 556 100000 0 1000000000 1000000000 301784193" "tests/44" 44
echo "Generating test #45"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 100000 0 100 1000000000 344814357" "tests/45" 45
echo "Generating test #46"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 100000 0 1000000000 1000000000 987400486" "tests/46" 46
echo "Generating test #47"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 879 313 100000 0 10 1000000000 930468184" "tests/47" 47
echo "Generating test #48"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 297 38 100000 0 100 1000000000 802508354" "tests/48" 48
echo "Generating test #49"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 106 488 100000 0 1000000000 1000000000 175282262" "tests/49" 49
echo "Generating test #50"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 100000 0 100 1000000000 61640979" "tests/50" 50
echo "Generating test #51"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 100000 0 1000000000 1000000000 101591000" "tests/51" 51
echo "Generating test #52"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 147 283 100000 3 10 1000000000 132410704" "tests/52" 52
echo "Generating test #53"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 495 24 100000 5 100 1000000000 839547081" "tests/53" 53
echo "Generating test #54"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 171 304 100000 1 1000000000 1000000000 758581989" "tests/54" 54
echo "Generating test #55"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 100000 10 100 1000000000 823147989" "tests/55" 55
echo "Generating test #56"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 100000 10 1000000000 1000000000 788054093" "tests/56" 56
echo "Generating test #57"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 474 458 100000 7 10 1000000000 228788895" "tests/57" 57
echo "Generating test #58"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 7 286 100000 8 100 1000000000 71023707" "tests/58" 58
echo "Generating test #59"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 906 770 100000 9 1000000000 1000000000 750337043" "tests/59" 59
echo "Generating test #60"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 100000 10 100 1000000000 67710099" "tests/60" 60
echo "Generating test #61"
scripts/gen-input-via-stdout.sh "python3 files/gen_rand.pys3 1000 1000 100000 10 1000000000 1000000000 11395339" "tests/61" 61
echo ""
echo "Generating answer for test #1"
scripts/gen-answer.sh tests/01 tests/01.a "tests" "0"
echo ""
echo "Generating answer for test #2"
scripts/gen-answer.sh tests/02 tests/02.a "tests" "1"
echo ""
echo "Generating answer for test #3"
scripts/gen-answer.sh tests/03 tests/03.a "tests" "1"
echo ""
echo "Generating answer for test #4"
scripts/gen-answer.sh tests/04 tests/04.a "tests" "1"
echo ""
echo "Generating answer for test #5"
scripts/gen-answer.sh tests/05 tests/05.a "tests" "1"
echo ""
echo "Generating answer for test #6"
scripts/gen-answer.sh tests/06 tests/06.a "tests" "1"
echo ""
echo "Generating answer for test #7"
scripts/gen-answer.sh tests/07 tests/07.a "tests" "1"
echo ""
echo "Generating answer for test #8"
scripts/gen-answer.sh tests/08 tests/08.a "tests" "1"
echo ""
echo "Generating answer for test #9"
scripts/gen-answer.sh tests/09 tests/09.a "tests" "1"
echo ""
echo "Generating answer for test #10"
scripts/gen-answer.sh tests/10 tests/10.a "tests" "1"
echo ""
echo "Generating answer for test #11"
scripts/gen-answer.sh tests/11 tests/11.a "tests" "1"
echo ""
echo "Generating answer for test #12"
scripts/gen-answer.sh tests/12 tests/12.a "tests" "2"
echo ""
echo "Generating answer for test #13"
scripts/gen-answer.sh tests/13 tests/13.a "tests" "2"
echo ""
echo "Generating answer for test #14"
scripts/gen-answer.sh tests/14 tests/14.a "tests" "2"
echo ""
echo "Generating answer for test #15"
scripts/gen-answer.sh tests/15 tests/15.a "tests" "2"
echo ""
echo "Generating answer for test #16"
scripts/gen-answer.sh tests/16 tests/16.a "tests" "2"
echo ""
echo "Generating answer for test #17"
scripts/gen-answer.sh tests/17 tests/17.a "tests" "2"
echo ""
echo "Generating answer for test #18"
scripts/gen-answer.sh tests/18 tests/18.a "tests" "2"
echo ""
echo "Generating answer for test #19"
scripts/gen-answer.sh tests/19 tests/19.a "tests" "2"
echo ""
echo "Generating answer for test #20"
scripts/gen-answer.sh tests/20 tests/20.a "tests" "2"
echo ""
echo "Generating answer for test #21"
scripts/gen-answer.sh tests/21 tests/21.a "tests" "2"
echo ""
echo "Generating answer for test #22"
scripts/gen-answer.sh tests/22 tests/22.a "tests" "3"
echo ""
echo "Generating answer for test #23"
scripts/gen-answer.sh tests/23 tests/23.a "tests" "3"
echo ""
echo "Generating answer for test #24"
scripts/gen-answer.sh tests/24 tests/24.a "tests" "3"
echo ""
echo "Generating answer for test #25"
scripts/gen-answer.sh tests/25 tests/25.a "tests" "3"
echo ""
echo "Generating answer for test #26"
scripts/gen-answer.sh tests/26 tests/26.a "tests" "3"
echo ""
echo "Generating answer for test #27"
scripts/gen-answer.sh tests/27 tests/27.a "tests" "3"
echo ""
echo "Generating answer for test #28"
scripts/gen-answer.sh tests/28 tests/28.a "tests" "3"
echo ""
echo "Generating answer for test #29"
scripts/gen-answer.sh tests/29 tests/29.a "tests" "3"
echo ""
echo "Generating answer for test #30"
scripts/gen-answer.sh tests/30 tests/30.a "tests" "3"
echo ""
echo "Generating answer for test #31"
scripts/gen-answer.sh tests/31 tests/31.a "tests" "3"
echo ""
echo "Generating answer for test #32"
scripts/gen-answer.sh tests/32 tests/32.a "tests" "4"
echo ""
echo "Generating answer for test #33"
scripts/gen-answer.sh tests/33 tests/33.a "tests" "4"
echo ""
echo "Generating answer for test #34"
scripts/gen-answer.sh tests/34 tests/34.a "tests" "4"
echo ""
echo "Generating answer for test #35"
scripts/gen-answer.sh tests/35 tests/35.a "tests" "4"
echo ""
echo "Generating answer for test #36"
scripts/gen-answer.sh tests/36 tests/36.a "tests" "4"
echo ""
echo "Generating answer for test #37"
scripts/gen-answer.sh tests/37 tests/37.a "tests" "4"
echo ""
echo "Generating answer for test #38"
scripts/gen-answer.sh tests/38 tests/38.a "tests" "4"
echo ""
echo "Generating answer for test #39"
scripts/gen-answer.sh tests/39 tests/39.a "tests" "4"
echo ""
echo "Generating answer for test #40"
scripts/gen-answer.sh tests/40 tests/40.a "tests" "4"
echo ""
echo "Generating answer for test #41"
scripts/gen-answer.sh tests/41 tests/41.a "tests" "4"
echo ""
echo "Generating answer for test #42"
scripts/gen-answer.sh tests/42 tests/42.a "tests" "5"
echo ""
echo "Generating answer for test #43"
scripts/gen-answer.sh tests/43 tests/43.a "tests" "5"
echo ""
echo "Generating answer for test #44"
scripts/gen-answer.sh tests/44 tests/44.a "tests" "5"
echo ""
echo "Generating answer for test #45"
scripts/gen-answer.sh tests/45 tests/45.a "tests" "5"
echo ""
echo "Generating answer for test #46"
scripts/gen-answer.sh tests/46 tests/46.a "tests" "5"
echo ""
echo "Generating answer for test #47"
scripts/gen-answer.sh tests/47 tests/47.a "tests" "5"
echo ""
echo "Generating answer for test #48"
scripts/gen-answer.sh tests/48 tests/48.a "tests" "5"
echo ""
echo "Generating answer for test #49"
scripts/gen-answer.sh tests/49 tests/49.a "tests" "5"
echo ""
echo "Generating answer for test #50"
scripts/gen-answer.sh tests/50 tests/50.a "tests" "5"
echo ""
echo "Generating answer for test #51"
scripts/gen-answer.sh tests/51 tests/51.a "tests" "5"
echo ""
echo "Generating answer for test #52"
scripts/gen-answer.sh tests/52 tests/52.a "tests" "6"
echo ""
echo "Generating answer for test #53"
scripts/gen-answer.sh tests/53 tests/53.a "tests" "6"
echo ""
echo "Generating answer for test #54"
scripts/gen-answer.sh tests/54 tests/54.a "tests" "6"
echo ""
echo "Generating answer for test #55"
scripts/gen-answer.sh tests/55 tests/55.a "tests" "6"
echo ""
echo "Generating answer for test #56"
scripts/gen-answer.sh tests/56 tests/56.a "tests" "6"
echo ""
echo "Generating answer for test #57"
scripts/gen-answer.sh tests/57 tests/57.a "tests" "6"
echo ""
echo "Generating answer for test #58"
scripts/gen-answer.sh tests/58 tests/58.a "tests" "6"
echo ""
echo "Generating answer for test #59"
scripts/gen-answer.sh tests/59 tests/59.a "tests" "6"
echo ""
echo "Generating answer for test #60"
scripts/gen-answer.sh tests/60 tests/60.a "tests" "6"
echo ""
echo "Generating answer for test #61"
scripts/gen-answer.sh tests/61 tests/61.a "tests" "6"
echo ""

