import java.io.*;
import java.util.*;

public class gpk_ma {
    String fileName = "";

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        int k = nextInt();
        int s = nextInt();
        int[] a = new int[k];
        for (int i = 0; i < k; i++) {
            a[i] = nextInt();
        }
        int[] b = new int[n];
        for (int i = 0; i < n; i++) {
            b[i] = nextInt();
        }
        int[][] sc = new int[n][m];
        for (int i = 0; i < m; i++) {
            for (int j = 0; j < n; j++) {
                int p = nextInt() - 1;
                if (j < k) {
                    sc[p][i] = a[j];
                } else {
                    sc[p][i] = 0;
                }
            }
        }
        long[] tot = new long[n];
        for (int i = 0; i < n; i++) {
            Arrays.sort(sc[i]);
            for (int j = 0; j < m; j++) {
                tot[i] += sc[i][j];
            }
        }
        int q = nextInt();
        for (int qq = 0; qq < q; qq++) {
            int u = nextInt() - 1;
            int v = nextInt() - 1;
            int L = -1;
            int R = 1_001_000_000;
            while (R - L > 1) {
                int M = (L + R) / 2;
                int vu = (k == n ? a[k - 1] : 0);
                long scu = b[u] + tot[u] + (long) M * vu;
                long scv = b[v] + tot[v] + (long) M * a[0];

                int lu = M;
                int iu = 0;
                for (int j = 0; j < s; j++) {
                    if (lu == 0) {
                        scu -= sc[u][iu++];
                    } else if (iu == m) {
                        scu -= vu;
                        lu--;
                    } else {
                        if (sc[u][iu] < vu) {
                            scu -= sc[u][iu++];
                        } else {
                            scu -= vu;
                            lu--;
                        }
                    }
                }

                int lv = M;
                int iv = 0;
                for (int j = 0; j < s; j++) {
                    if (lv == 0) {
                        scv -= sc[v][iv++];
                    } else if (iv == m) {
                        scv -= a[0];
                        lv--;
                    } else {
                        if (sc[v][iv] < a[0]) {
                            scv -= sc[v][iv++];
                        } else {
                            scv -= a[0];
                            lv--;
                        }
                    }
                }

                if (scu < scv) {
                    R = M;
                } else {
                    L = M;
                }
            }

            out.println(R);
        }
    }

    public void run() {
        try {
            if (fileName.equals("")) {
                br = new BufferedReader(new InputStreamReader(System.in));
                out = new PrintWriter(System.out);
            } else if (fileName.equals("txt")) {
                br = new BufferedReader(new FileReader("input.txt"));
                out = new PrintWriter("output.txt");
            } else {
                br = new BufferedReader(new FileReader(fileName + ".in"));
                out = new PrintWriter(fileName + ".out");
            }

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new gpk_ma().run();
    }

}