#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef int LL;

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
    cin.tie(0);
    cin.sync_with_stdio(0);

    int n, m, k, s;
    cin >> n >> m >> k >> s;

    vector<int> a(n);
    for (int i = 0; i < k; ++i)
        cin >> a[i];

    vector<LL> b(n);
    for (int i = 0; i < n; ++i)
        cin >> b[i];

    vector<vector<int>> got(n);
    vector<LL> addsum(n);

    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < n; ++j) {
            int id;
            cin >> id;
            id--;

            int db = a[j];
            got[id].push_back(db);
            addsum[id] += db;
        }
        for (int j = 0; j < n; ++j)
            if (got[j].size() != i + 1)
                got[j].push_back(0);
    }

    for (int i = 0; i < n; ++i)
        sort(got[i].begin(), got[i].end());

    int q;
    cin >> q;

    while (q--) {
        int u, v;
        cin >> u >> v;
        --u;
        --v;

        // -> b[v] > v[u]

        LL curv = b[v] + addsum[v];
        LL curu = b[u] + addsum[u];

        // v + a[0]
        // u + a.back()

        int itu = s - 1;

        for (int i = 0; i < s; ++i)
            curv -= got[v][i], curu -= got[u][i];

        int ans = 0;

        while (itu >= 0) {
            if (curv > curu) break;
            ans++;
            curv += a[0];

            curu += got[u][itu];
            itu--;
        }

        if (curv > curu) {
            cout << ans << '\n';
            continue;
        }

        LL D = curu - curv + 1;

        LL d = a[0] - a.back();

        cout << ans + (D + d - 1) / d << '\n';
    }

    return 0;
}
