#include "testlib.h"
#include <bits/stdc++.h>
#define forn(i,n) for (int i = 0; i < n; i++)
#define sz(a) (int)a.size()
using namespace std;
typedef long long ll;
const long long CMAX = ll(1e15);

vector<long long> a;

bool ok(ll cc, ll bb) {
	bool ok = false;
    if (cc > bb) swap(cc, bb);
    forn (ik, 256) {
        auto b = a;
        int j = ik;
        forn (jj, 4) {
            if (jj % 2)
                b[j % 4] -= cc;
            else
                b[j % 4] -= bb;
            j /= 4;
        }
        if (b[0] >= 0 && b[1] >= 0 && b[2] >= 0 && b[3] >= 0) {
            ok = true;
            break;
        }
    }
    return ok;
}

vector<ll> multiply(ll a, ll b) {
	vector<ll> ans(4, 0);
	ll aa[2] = {a%ll(1e9), a/ll(1e9)},
	   bb[2] = {b%ll(1e9), b/ll(1e9)};
	forn (i, 2) {
		forn (j, 2)
			ans[i + j] += aa[i] * bb[j];
	}
	forn (k, 3) {
		ans[k + 1] += ans[k] / ll(1e9);
		ans[k] %= ll(1e9);
	}
	reverse(ans.begin(), ans.end());
	return ans;
}

int main(int argc, char * argv[])
{
   setName("Sticks");
   registerTestlibCmd(argc, argv);
   a.resize(4);
   forn (i, 4) a[i] = inf.readLong(1, CMAX);
   sort(a.rbegin(), a.rend());
   long long ja = ans.readLong(1, CMAX), jb = ans.readLong(1, CMAX);
   long long jc = ouf.readLong(1, CMAX), jd = ouf.readLong(1, CMAX);
   if (!ok(ja, jb)) quitf(_fail, "bad_jury_answer");
   if (!ok(jc, jd)) quitf(_wa, "bad_answer");
   if (multiply(ja, jb) < multiply(jc, jd))
   		quitf(_fail, "pariticipant solution is better");
   if (multiply(ja, jb) == multiply(jc, jd))
   		quitf(_ok, "pariticipant solution is ok");
   	quitf(_wa, "participant has solution lower than jury");
}       