#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
#define __int128 long double

pair<ll, ll> solve(ll a, ll b, ll c, ll d) {
	vector<ll> v = { a, b, c, d };
	sort(v.begin(), v.end());

	ll ans1 = 0, ans2 = 0;

	auto cmp = [&](ll a1, ll a2, ll b1, ll b2) {
		__int128 a3 = (__int128)a1 * a2;
		__int128 b3 = (__int128)b1 * b2;
		return a3 > b3 || a3 == b3 && a1 * a2 - b1 * b2 > 0;
	};

	auto f = [&](ll mx) {
		__int128 cans = 0;
		for (int i = 0; i < 4; i++) {
			for (int j = i; j < 4; j++) {
				auto g = v;
				g[i] -= mx;
				g[j] -= mx;
				sort(g.begin(), g.end());
				if (g[0] >= 0) {
					ll cans1 = mx;
					ll cans2 = max(g[3] / 2, g[2]);
					if (cmp(cans1, cans2, ans1, ans2)) {
						ans1 = cans1;
						ans2 = cans2;
					}
					cans = max(cans, (__int128)cans1 * cans2);
				}
			}
		}
		return cans;
	};

	ll L = 1, R = max(v[2], v[3] / 2);
	while (R - L > 1e5) {
		ll l1 = (L + L + R) / 3;
		ll r1 = (L + R + R) / 3;
		if (f(l1) >= f(r1)) {
			R = r1;
		}
		else {
			L = l1;
		}
	}
	for (ll i = L; i <= R; i++) f(i);
	
	return { ans1, ans2 };
}

int main() {
	ll a, b, c, d;
	while (cin >> a >> b >> c >> d) {
		auto o = solve(a, b, c, d);
		cout << o.first << " " << o.second << endl;
	}

	return 0;
}