#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXN = 2007;
int field[MAXN][MAXN];
ll d1[MAXN][MAXN], d2[MAXN][MAXN];

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			cin >> field[i][j];
		}
	}
	for (int i = 0; i < MAXN; ++i) {
		for (int j = 0; j < MAXN; ++j) {
			d1[i][j] = d2[i][j] = -INFL;
		}
	}
	d1[0][0] = 0;
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
			d1[i + 1][j] = d1[i][j];
			if (j > 0) {
				d1[i + 1][j] = max(d1[i + 1][j], d1[i + 1][j - 1]);
			}
			d1[i + 1][j] += field[i][j];
		}
	}
	d2[n][m - 1] = 0;
	for (int i = n - 1; i >= 0; --i) {
		for (int j = m - 1; j >= 0; --j) {
			d2[i][j] = d2[i + 1][j];
			if (j < m - 1) {
				d2[i][j] = max(d2[i][j], d2[i][j + 1]);
			}
			d2[i][j] += field[i][j];
		}
	}

	/*
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j < m; ++j) {
			cerr << d1[i][j] << " ";
		}
		cerr << endl;
	}
	for (int i = 0; i <= n; ++i) {
		for (int j = 0; j < m; ++j) {
			cerr << d2[i][j] << " ";
		}
		cerr << endl;
	}
	*/

	ll ans = INFL;
	for (int i = 0; i < n; ++i) {
		vector<ll> suff = {-INFL};
		for (int j = m - 1; j >= 0; --j) {
			suff.push_back(max(suff.back(), d1[i][j] + d2[i][j]));
		}
		reverse(suff.begin(), suff.end());
		ll pref = -INFL;
		for (int j = 0; j < m; ++j) {
			if (i == 0 && j == 0) {
				continue;
			}
			if (i == n - 1 && j == m - 1) {
				continue;
			}
			
			ll cur = -INFL;
			if (j < m - 1 && i > 0) {
				//cerr << i << " " << j << " " << d1[i + 1][j] + d2[i + 1][j] << endl;
				cur = max(cur, suff[j + 1]);
			}
			if (j && i < n - 1) {
				//cerr << i << " " << j << " " << d1[i][j] + d2[i][j] << endl;
				pref = max(pref, d1[i + 1][j - 1] + d2[i + 1][j - 1]);
				cur = max(pref, cur);
			}
			//cerr << i << " " << j << " " << cur << endl;
			ans = min(ans, cur);
		}
	}
	cout << ans << "\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
#ifdef LOCAL
	cerr << "time: " << clock() << " ms\n";
#endif
	return 0;
}