#include <iostream>
#include <vector>

using namespace std;

int dx[] = {-1, 1, 0, 0};
int dy[] = {0, 0, -1, 1};

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif

    int r, c;
    cin >> r >> c;
    int n;
    cin >> n;
    vector<vector<bool>> a(r, vector<bool> (c));
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        x--;
        y--;

        a[x][y] = true;
    }

    int cnt = 0;
    while (true) {
        bool ok = true;
        vector<vector<bool>> b(r, vector<bool> (c));

        for (int i = 0; i < r; i++) {
            for (int j = 0; j < c; j++) {
                if (!a[i][j]) {
                    ok = false;
                    for (int d = 0; d < 4; d++) {
                        int ii = i + dx[d], jj = j + dy[d];
                        if (0 <= ii && ii < r && 0 <= jj && jj < c && a[ii][jj]) {
                            b[i][j] = true;
                        }
                    }
                } else {
                    b[i][j] = true;
                }
            }
        }

        if (ok) {
            break;
        }

        cnt++;
        a = b;
    }

    cout << cnt << endl;

    return 0;
}
