#include <iostream>
#include <vector>

using namespace std;

int r, c;
int n;
vector<pair<int, int>> a;

int mind(int x, int y) {
    int mn = 2000000000;
    for (auto p : a) {
        mn = min(mn, abs(p.first - x) + abs(p.second - y));
    }
    return mn;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    cin >> r >> c;
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }

    int mx = 0;
    for (int i = 1; i <= r; i++) {
        mx = max(mx, mind(i, 1));
        mx = max(mx, mind(i, c));
    }
    for (int i = 1; i <= c; i++) {
        mx = max(mx, mind(1, i));
        mx = max(mx, mind(r, i));
    }

    cout << mx << endl;

    return 0;
}
