#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }

const int MAXN = 1e5 + 5;
pii scanline[MAXN * 2];
pii part1[MAXN];
pii part2[MAXN];
int used[MAXN];
int rmq[MAXN * 6];
int there[MAXN * 6];
int bpv;

void s_segplus(int v, int vl, int vr, int l, int r, int val) {
	if (vr <= l || r <= vl) {
		return;
	}
	if (l <= vl && vr <= r) {
		//cerr << "add " << v << " " << val << endl;
		there[v] += val;
		rmq[v] += val;
		return;
	}
	int vm = (vl + vr) / 2;
	s_segplus(v * 2, vl, vm, l, r, val);
	s_segplus(v * 2 + 1, vm, vr, l, r, val);
	rmq[v] = min(rmq[v * 2], rmq[v * 2 + 1]) + there[v];
}

int s_getmin(int v, int vl, int vr, int l, int r) {
	//cerr << v << " " << vl << " " << vr << " " << l << " " << r << endl;
	if (vr <= l || r <= vl) {
		return INF;
	}
	if (l <= vl && vr <= r) {
		//cerr << "here " << rmq[v] << endl;
		return rmq[v];
	}
	int vm = (vl + vr) / 2;
	return min(s_getmin(v * 2, vl, vm, l, r), s_getmin(v * 2 + 1, vm, vr, l, r)) + there[v];
}

void solve() {
	int r, c;
	int n;
	cin >> r >> c >> n;
	vector<pii> inp;
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		--x; --y;
		inp.push_back({x - y, x + y});
		part1[i] = {x - y, i};
		part2[i] = {x - y, i};
	}
	sort(part1, part1 + n);
	sort(part2, part2 + n);
	int lg = -1, rg = r + c + 1;
	int tcounter = 0;
	while (rg - lg > 1) {
		int mid = (lg + rg) / 2;
		
		for (int i = 0; i < n; ++i) {
			int ind = part1[i].ss;
			part1[i].ff = inp[ind].ff - mid;
			part2[i].ff = inp[ind].ff + mid + 1;
			//cerr << inp[ind].ff - mid << " " << inp[ind].ss - mid << " " << inp[ind].ff + mid + 1 << " " << inp[ind].ss + mid + 1 << endl;
		}
		merge(part1, part1 + n, part2, part2 + n, scanline);

		bpv = 1;
		while (bpv < r + c) {
			bpv *= 2;
		}

		fill(rmq, rmq + bpv * 2, 0);
		fill(there, there + bpv * 2, 0);
		tcounter++;

		int ly = c - 1, ry = c - 1 + 1;
		int cnt = 0;
		bool flag = true;
		for (int i = 1 - c; i <= r - 1; ++i) {
			while (cnt < n * 2 && scanline[cnt].ff <= i) {
				int ind = scanline[cnt].ss;
				int from = max(inp[ind].ss - mid, 0);
				int to = min(inp[ind].ss + mid + 1, bpv);
				if (used[ind] != tcounter) {
					used[ind] = tcounter;
					s_segplus(1, 0, bpv, from, to, 1);
				} else {
					s_segplus(1, 0, bpv, from, to, -1);
				}
				++cnt;
			}
			if (s_getmin(1, 0, bpv, ly, ry) == 0) {
				flag = false;
				break;
			}
			if (i < 0) {
				--ly;
			} else {
				++ly;
			}

			if (i < r - c) {
				++ry;
			} else {
				--ry;
			}
		}

		if (!flag) {
			lg = mid;
		} else {
			rg = mid;
		}
	}

	cout << rg << "\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}