#include "bits/stdc++.h"
#define ff first
#define ss second
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const ll INFL = 1e18 + 123;
const double PI = atan2(0, -1);
mt19937 tw(960172);
ll rnd(ll x, ll y) { static uniform_int_distribution<ll> d; return d(tw) % (y - x + 1) + x; }


void solve() {
	int n, k;
	cin >> n >> k;
	vector<int> inp;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		inp.push_back(num);
	}

	vector<int> ans;
	ll best = INFL;
	for (int i = -1; i <= 1; i += 2) {
		vector<int> tmp = inp;
		for (int j = 0; j < n; j += 2) {
			tmp[j] += k * i;
		}
		auto tmp2 = tmp;

		ll sum = 0;
		nth_element(tmp.begin(), tmp.begin() + szof(tmp) / 2, tmp.end());
		int val = tmp[szof(tmp) / 2];
		for (int num : tmp) {
			sum += abs(val - num);
		}

		if (sum < best) {
			best = sum;
			ans = vector<int>(n, val);
			for (int j = 0; j < n; j += 2) {
				ans[j] -= k * i;
			}
		}
	}
	ll val = 0;
	for (int i = 0; i < n; ++i) {
		val += abs((ll) inp[i] - ans[i]);
	}
	cout << val << "\n";
}


int main() {
	//freopen(TASK_NAME ".in", "r", stdin);
	//freopen(TASK_NAME ".out", "w", stdout);
	cerr << fixed << setprecision(15);
	cout << fixed << setprecision(15);
	ios::sync_with_stdio(false);

	int tests = 1;
	// cin >> tests;
	for (int it = 1; it <= tests; ++it) {
		solve();
	}
	
	#ifdef LOCAL
		cerr << "time: " << clock() << " ms\n";
	#endif
	return 0;
}