#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, k, s;
    cin >> n >> m >> k >> s;
    vector<int> a(k);
    for (int i = 0; i < k; i++) {
        cin >> a[i];
    }
    vector<int> b(n);
    for (int i = 0; i < n; i++) {
        cin >> b[i];
    }

    vector<vector<int>> sc(n);
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            int p;
            cin >> p;
            p--;
            if (j < k) {
                sc[p].push_back(a[j]);
            } else {
                sc[p].push_back(0);
            }
        }
    }
    for (int i = 0; i < n; i++) {
        sort(sc[i].begin(), sc[i].end());
    }

    int q;
    cin >> q;
    while (q--) {
        int u, v;
        cin >> u >> v;
        u--;
        v--;
        long long scu = b[u], scv = b[v];
        multiset<int> wu, wv;
        for (int i = 0; i < s; i++) {
            wu.insert(sc[u][i]);
            wv.insert(sc[v][i]);
        }
        for (int i = s; i < m; i++) {
            scu += sc[u][i];
            scv += sc[v][i];
        }
        int ans = 0;
        while (scu >= scv) {
            ans++;
            wu.insert(k == n ? a[k - 1] : 0);
            wv.insert(a[0]);

            scu += *wu.rbegin();
            wu.erase(wu.find(*wu.rbegin()));
            scv += *wv.rbegin();
            wv.erase(wv.find(*wv.rbegin()));
        }
        cout << ans << "\n";
    }

    return 0;
}
